/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.gebietsbaum.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.gebietsbaum.entity.GebietPolygonPoint;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class GebietPolygonPointExtendedDAO extends AbstractGebietPolygonPointDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: GebietOrderByPositionNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM GebietPolygonPoint o WHERE o.gebiet = ?1 ORDER BY o.position<br>
* SQL: <br>
*/
@Override
public java.util.List<GebietPolygonPoint> findByGebietOrderByPosition( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("GebietPolygonPoint.findByGebietOrderByPosition" ,  gebiet  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByGebietOrderByPosition(): Miss");
        }

        cache.put(key, super.findByGebietOrderByPosition( gebiet  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByGebietOrderByPosition(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<GebietPolygonPoint>) cache.lookup(key));
    }

    return super.findByGebietOrderByPosition( gebiet  );
}
/**
* Name: WahlNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM GebietPolygonPoint o WHERE o.gebiet.wahl = ?1<br>
* SQL: <br>
*/
@Override
public java.util.List<GebietPolygonPoint> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("GebietPolygonPoint.findByWahl" ,  wahl  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahl(): Miss");
        }

        cache.put(key, super.findByWahl( wahl  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahl(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<GebietPolygonPoint>) cache.lookup(key));
    }

    return super.findByWahl( wahl  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
